;*********************************************************************************************
;TWI (I2C) Bus zum Auslesen der einzelnen RTC Werte,
;Umwandlung von BCD in binre Zehner und Einer 
;und Speicherung im SRAM
;*********************************************************************************************
Sek_Read:								;und Speicherung im SRAM
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Sek_Register			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

;START lesen
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIrd
	out		TWDR, tempdat				;Slaveadresse "lesen" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte
	
	ldi		temp, (1<<TWINT | 1<<TWEA | 1<<TWEN) 	;ACK fr mehrere Datenbytes senden
	out		TWCR, temp
	rcall	Warte

	in		Wert_akt, TWDR				;Sekunden auslesen
	ldi		temp, (1<<TWINT | 0<<TWEA | 1<<TWEN) ;NACK senden
	out		TWCR, temp						
	rcall	Warte	

	ldi 	ZL,low(Sek_Z)				;Zeiger auf SRAM-Location "Sekunden"
	ldi 	ZH,high(Sek_Z)

	mov 	temp,Wert_akt
	rcall	BCD_Aufl	

;STOP
	ldi		temp, (1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
	out		TWCR, temp					;Stoppbedingung ausgeben

	ldi		RTCCnt, 1
	rjmp	Mainloop

Min_Read:
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Min_Register			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

;START lesen
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIrd
	out		TWDR, tempdat				;Slaveadresse "lesen" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte
	
	ldi		temp, (1<<TWINT | 1<<TWEA | 1<<TWEN) ;ACK fr mehrere Datenbytes senden
	out		TWCR, temp
	rcall	Warte

	in		Wert_akt, TWDR					
	ldi		temp, (1<<TWINT | 0<<TWEA | 1<<TWEN) ;NACK senden
	out		TWCR, temp						
	rcall	Warte	

	ldi 	ZL,low(Min_Z)				;Zeiger auf SRAM-Location "Minuten"
	ldi 	ZH,high(Min_Z)

	mov 	temp,Wert_akt
	rcall	BCD_Aufl	


;STOP
	ldi		temp, (1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
	out		TWCR, temp					;Stoppbedingung ausgeben

	ldi		RTCCnt, 1
	rjmp	Mainloop

Std_Read:
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Std_Register			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

;START lesen
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIrd
	out		TWDR, tempdat				;Slaveadresse "lesen" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte
	
	ldi		temp, (1<<TWINT | 1<<TWEA | 1<<TWEN) ;ACK fr mehrere Datenbytes senden
	out		TWCR, temp
	rcall	Warte

	in		Wert_akt, TWDR					
	ldi		temp, (1<<TWINT | 0<<TWEA | 1<<TWEN) ;NACK senden
	out		TWCR, temp						
	rcall	Warte	

	ldi 	ZL,low(Std_Z)				;Zeiger auf SRAM-Location "Stunden"
	ldi 	ZH,high(Std_Z)

	mov 	temp,Wert_akt
	rcall	BCD_Aufl	


;STOP
	ldi		temp, (1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
	out		TWCR, temp					;Stoppbedingung ausgeben

	ldi		RTCCnt, 1
	rjmp	Mainloop

WTag_Read:
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Tag_Register			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

;START lesen
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIrd
	out		TWDR, tempdat				;Slaveadresse "lesen" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte
	
	ldi		temp, (1<<TWINT | 1<<TWEA | 1<<TWEN) ;ACK fr mehrere Datenbytes senden
	out		TWCR, temp
	rcall	Warte

	in		Wert_akt, TWDR					
	ldi		temp, (1<<TWINT | 0<<TWEA | 1<<TWEN) ;NACK senden
	out		TWCR, temp						
	rcall	Warte	

	ldi 	ZL,low(WTag_dummy)			;Zeiger auf SRAM-Location "Wochentag"
	ldi 	ZH,high(WTag_dummy)

	mov 	temp,Wert_akt
	rcall	BCD_Aufl	

;STOP
	ldi		temp, (1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
	out		TWCR, temp					;Stoppbedingung ausgeben

	ldi		RTCCnt, 1
	rjmp	Mainloop

Dat_Read:
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Dat_Register			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

;START lesen
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIrd
	out		TWDR, tempdat				;Slaveadresse "lesen" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte
	
	ldi		temp, (1<<TWINT | 1<<TWEA | 1<<TWEN) ;ACK fr mehrere Datenbytes senden
	out		TWCR, temp
	rcall	Warte

	in		Wert_akt, TWDR					
	ldi		temp, (1<<TWINT | 0<<TWEA | 1<<TWEN) ;NACK senden
	out		TWCR, temp						
	rcall	Warte	

	ldi 	ZL,low(Dat_Z)				;Zeiger auf SRAM-Location "Datum"
	ldi 	ZH,high(Dat_Z)

	mov 	temp,Wert_akt
	rcall	BCD_Aufl	


;STOP
	ldi		temp, (1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
	out		TWCR, temp					;Stoppbedingung ausgeben

	ldi		RTCCnt, 1
	rjmp	Mainloop

Mon_Read:
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Mon_Register			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

;START lesen
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIrd
	out		TWDR, tempdat				;Slaveadresse "lesen" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte
	
	ldi		temp, (1<<TWINT | 1<<TWEA | 1<<TWEN) ;ACK fr mehrere Datenbytes senden
	out		TWCR, temp
	rcall	Warte

	in		Wert_akt, TWDR					
	ldi		temp, (1<<TWINT | 0<<TWEA | 1<<TWEN) ;NACK senden
	out		TWCR, temp						
	rcall	Warte	

	ldi 	ZL,low(Mon_dummy)			;Zeiger auf SRAM-Location "Monat"
	ldi 	ZH,high(Mon_dummy)

	mov 	temp,Wert_akt
	rcall	BCD_Aufl	

;STOP
	ldi		temp, (1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
	out		TWCR, temp					;Stoppbedingung ausgeben

	ldi		RTCCnt, 1
	rjmp	Mainloop

Jahr_Read:
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte	

	ldi 	tempdat, Jahr_Register			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Registeradresse ausgeben
	rcall	Warte	

;START lesen
	ldi		temp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, temp					;Startbedingung ausgeben
	rcall	Warte						;warte bis TWINT = 0

	ldi		tempdat,I2CDispAdr + TWIrd
	out		TWDR, tempdat				;Slaveadresse "lesen" laden
	ldi		temp, (1<<TWINT | 1<<TWEN)
	out		TWCR, temp					;Slaveadresse ausgeben
	rcall	Warte
	
	ldi		temp, (1<<TWINT | 1<<TWEA | 1<<TWEN) ;ACK fr mehrere Datenbytes senden
	out		TWCR, temp
	rcall	Warte

	in		Wert_akt, TWDR					
	ldi		temp, (1<<TWINT | 0<<TWEA | 1<<TWEN) ;NACK senden
	out		TWCR, temp						
	rcall	Warte	

	ldi 	ZL,low(Jahr_Z)				;Zeiger auf SRAM-Location "Jahr"
	ldi 	ZH,high(Jahr_Z)

	mov 	temp,Wert_akt
	rcall	BCD_Aufl	

;STOP
	ldi		temp, (1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
	out		TWCR, temp					;Stoppbedingung ausgeben

	ldi		RTCCnt, 1
	rjmp	Mainloop

;********************************************************************************
BCD_Aufl:								;Umwandlung BCD in Binr
	push	temp
	rcall	BCD_loop
	pop		temp
	swap	temp

BCD_loop:
	andi	temp, 0xF0
	swap	temp
	st		Z+, temp					;Speicherung im SRAM
	ret	
